// Page1.cpp : ʵļ
//

#include "stdafx.h"
#include "ProxyUI.h"
#include "Page1.h"
#include "MainTab.h"
#include "Page2.h"
#include "Page4.h"

// CPage1 Ի

IGlobalProxy* g_GlobalProxy = NULL;

IMPLEMENT_DYNAMIC(CPage1, CDialog)

CPage1::CPage1(CWnd* pParent /*=NULL*/)
	: CDialog(CPage1::IDD, pParent)
{
	m_pTestProxy = 0;
	m_pProxyTester = 0;
	m_bIsTesting = FALSE;
}

CPage1::~CPage1()
{
	if (m_pProxyTester)
	{
		m_pProxyTester->Release();
		m_pProxyTester = NULL;
	}
	if (m_pTestProxy)
	{
		ReleaseGlobalProxyInstance();
		m_pTestProxy = NULL;
	}
}

void CPage1::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDOK, m_OK);
	DDX_Control(pDX, IDCANCEL, m_Cancel);

	DDX_Control(pDX, IDC_CB_PROXYTYPE, m_cbProxyType);
	DDX_Control(pDX, IDC_EDIT_ADDR, m_edit_HostName);
	DDX_Control(pDX, IDC_EDIT_PORT, m_edit_Port);
	DDX_Control(pDX, IDC_EDIT_USER, m_edit_User);
	DDX_Control(pDX, IDC_EDIT_PASS, m_edit_Pass);
	DDX_Control(pDX, IDC_CHECK1, m_btnUDPAddrCheck);
	DDX_Control(pDX, IDC_TestProxy, m_btnTest);
	DDX_Control(pDX, IDC_CHECK_HOOKTCP, m_btnHookTCP);
	DDX_Control(pDX, IDC_CHECK_HOOK_UDP, m_btnHookUDP);
	DDX_Control(pDX, IDC_RADIO_DNSLOCAL, m_btnDNSLocal);
	DDX_Control(pDX, IDC_RADIO_DNSREMOTE, m_btnDNSRemote);
	DDX_Control(pDX, IDC_CHECK_HOOKCHILDPROCESS, m_btnHookChildProcess);
	DDX_Control(pDX, IDC_STATIC_TestProxy, m_staticTestProxy);
}


BEGIN_MESSAGE_MAP(CPage1, CDialog)

	ON_WM_SIZE()
	ON_BN_CLICKED(IDOK, &CPage1::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CPage1::OnBnClickedCancel)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_TestProxy, &CPage1::OnBnClickedTestproxy)
END_MESSAGE_MAP()

BOOL CPage1::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_OK.EnableWindow(TRUE);
	m_Cancel.EnableWindow(FALSE);
	m_staticTestProxy.SetWindowText(_T(""));

	m_cbProxyType.AddString(_T("NOPROXY"));
	m_cbProxyType.AddString(_T("SOCKS4"));
	m_cbProxyType.AddString(_T("SOCKS4A"));
	m_cbProxyType.AddString(_T("SOCKS5"));
	m_cbProxyType.AddString(_T("HTTP10"));
	m_cbProxyType.AddString(_T("HTTP11"));


	CString szHostname = theApp.GetProfileString(_T("proxyinfo"), _T("Host"));

	if(szHostname.GetLength() == 0)
	{
		m_cbProxyType.SelectString(0, _T("SOCKS5"));
		m_edit_HostName.SetWindowText(_T(""));//59.39.59.6
		m_edit_Port.SetWindowText(_T("1080"));
		m_edit_User.SetWindowText(_T(""));
		m_edit_Pass.SetWindowText(_T(""));
		GetSettings(&m_ProxyInfo);

		m_btnHookTCP.SetCheck(BST_CHECKED);
		m_btnHookUDP.SetCheck(BST_CHECKED);
		m_btnUDPAddrCheck.SetCheck(BST_CHECKED);
		m_btnDNSLocal.SetCheck(BST_CHECKED);
		m_btnHookChildProcess.SetCheck(BST_UNCHECKED);
	}else
	{
		CString szType, szHost, szPort, szUser, szPass;

		szType = theApp.GetProfileString(_T("proxyinfo"), _T("Type"));
		szHost = theApp.GetProfileString(_T("proxyinfo"), _T("Host"));
		szPort.Format(_T("%d"), theApp.GetProfileInt(_T("proxyinfo"), _T("Port"), 1308));
		szUser = theApp.GetProfileString(_T("proxyinfo"), _T("User"));
		szPass = theApp.GetProfileString(_T("proxyinfo"), _T("Pass"));

		m_cbProxyType.SelectString(0, szType);
		m_edit_HostName.SetWindowText(szHost);
		m_edit_Port.SetWindowText(szPort);
		m_edit_User.SetWindowText(szUser);
		m_edit_Pass.SetWindowText(szPass);

		GetSettings(&m_ProxyInfo);

		m_btnUDPAddrCheck.SetCheck(theApp.GetProfileInt(_T("proxyinfo"), _T("UDPAddr"), BST_UNCHECKED));
		m_btnHookTCP.SetCheck(theApp.GetProfileInt(_T("proxyinfo"), _T("HookTCP"), BST_UNCHECKED));
		m_btnHookUDP.SetCheck(theApp.GetProfileInt(_T("proxyinfo"), _T("HookUDP"), BST_UNCHECKED));
		m_btnHookChildProcess.SetCheck(theApp.GetProfileInt(_T("proxyinfo"), _T("HookChildProcess"), BST_UNCHECKED));

		m_btnDNSLocal.SetCheck(theApp.GetProfileInt(_T("proxyinfo"), _T("DNSOption"), BST_UNCHECKED));
		m_btnDNSRemote.SetCheck(!m_btnDNSLocal.GetCheck());

	}

	return TRUE;
}

void CPage1::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	// TODO: ڴ˴Ϣ
}

BOOL CPage1::GetProxyInfo(const LPPRCClient pPRCC, LPProxyInfo lpPI)
{
	//һϢ
	//pPRCCϢΪ ôϢ IDӵĿĵصȣ
	//ҪĻһЩ

	if(m_btnUDPAddrCheck.GetCheck() == BST_CHECKED)
	{
		pPRCC->uaFlag = UAF_SET_ADDR|UAF_SET_PORT;
		pPRCC->udpAddr.SetIPLong(0);
		pPRCC->udpAddr.SetPort(0);
	}

	*lpPI = m_ProxyInfo;
	return TRUE;
}

BOOL CPage1::GetProxySettings(LPProxySettingsInfo lpPSI)
{
	ProxySettingsInfo psi;

	psi.bHookTCP = m_btnHookTCP.GetCheck() == BST_CHECKED;
	psi.bHookUDP = m_btnHookUDP.GetCheck() == BST_CHECKED;
	psi.bHookCreateProcess = m_btnHookChildProcess.GetCheck();
	psi.nDNSOption = m_btnDNSLocal.GetCheck() ? PSI_DNSOPT_LOCAL : PSI_DNSOPT_REMOTE;

	*lpPSI = psi;
	return TRUE;
}

BOOL CPage1::GetSettings(OUT LPProxyInfo lpPI)
{

	CString szType, szHost, szPort, szUser, szPass;

	m_cbProxyType.GetLBText(m_cbProxyType.GetCurSel(), szType);
	m_edit_HostName.GetWindowText(szHost);
	m_edit_Port.GetWindowText(szPort);
	m_edit_User.GetWindowText(szUser);
	m_edit_Pass.GetWindowText(szPass);

	if (!szHost.GetLength() || !szPort.GetLength() || !_ttoi(szPort))
		return FALSE;

	ProxyInfo pi;

	pi.szItemName = "myproxy";
	pi.strProxyType = ((CStringA)szType).GetBuffer();
	pi.strProxyHost = ((CStringA)szHost).GetBuffer();
	pi.nProxyPort = atoi(((CStringA)szPort).GetBuffer());
	pi.strProxyUser = ((CStringA)szUser).GetBuffer();
	pi.strProxyPass = ((CStringA)szPass).GetBuffer();

	*lpPI = pi;
	return TRUE;
}

void CPage1::OnBnClickedOk()
{
	// TODO: ڴӿؼ֪ͨ

	g_GlobalProxy = GetGlobalProxyInstance();

	if(!g_GlobalProxy)
		return;

	//һLogĴ
	CMainTab *pParent = g_MainTab;
	CPage2 *pPage2 = pParent->GetPage2();
	CPage3 *pPage3 = pParent->GetPage3();
	IProxyLog *pLog = g_GlobalProxy->GetLogInstance();
	pLog->AddInstance(pPage2);
	pLog->AddInstance(pPage3);

	//һײѯõĶ
	//ײڴÿ֮ǰͨѯǰõĴϢ
	IProxySettings *pSettings = g_GlobalProxy->GetSettingsInstance();
	pSettings->AddInstance(this);

	if (!GetSettings(&m_ProxyInfo))
	{
		MessageBox(_T("дȷ?"), 0, MB_ICONERROR);
		return;
	}
	
	if (m_ProxyInfo.GetProxyType() != PROXYTYPE_SOCKS5)
	{
		m_btnHookUDP.SetCheck(BST_UNCHECKED);
	}

	if(g_GlobalProxy->EnableProxy())
	{
		m_OK.EnableWindow(FALSE);
		m_Cancel.EnableWindow(TRUE);
	}else
	{
		ReleaseGlobalProxyInstance();
		g_GlobalProxy = NULL;
	}

}

void CPage1::OnBnClickedCancel()
{
	// TODO: ڴӿؼ֪ͨ
	if(!g_GlobalProxy)
		return;

	if(g_GlobalProxy->DisableProxy())
	{
		ReleaseGlobalProxyInstance();
		m_OK.EnableWindow(TRUE);
		m_Cancel.EnableWindow(FALSE);
		g_GlobalProxy = NULL;
	}
}

void CPage1::OnDestroy()
{
	CDialog::OnDestroy();

	// TODO: ڴ˴Ϣ
	OnBnClickedCancel();

	if (GetSettings(&m_ProxyInfo))
	{
		theApp.WriteProfileString(_T("proxyinfo"), _T("Type"), (CString)m_ProxyInfo.strProxyType);
		theApp.WriteProfileString(_T("proxyinfo"), _T("Host"), (CString)m_ProxyInfo.strProxyHost);
		theApp.WriteProfileInt(_T("proxyinfo"), _T("Port"), m_ProxyInfo.nProxyPort);
		theApp.WriteProfileString(_T("proxyinfo"), _T("User"), (CString)m_ProxyInfo.strProxyUser);
		theApp.WriteProfileString(_T("proxyinfo"), _T("Pass"), (CString)m_ProxyInfo.strProxyPass);

		theApp.WriteProfileInt(_T("proxyinfo"), _T("UDPAddr"), m_btnUDPAddrCheck.GetCheck());
		theApp.WriteProfileInt(_T("proxyinfo"), _T("HookTCP"), m_btnHookTCP.GetCheck());
		theApp.WriteProfileInt(_T("proxyinfo"), _T("HookUDP"), m_btnHookUDP.GetCheck());
		theApp.WriteProfileInt(_T("proxyinfo"), _T("HookChildProcess"), m_btnHookChildProcess.GetCheck());

		theApp.WriteProfileInt(_T("proxyinfo"), _T("DNSOption"), m_btnDNSLocal.GetCheck());
	}

}


void CPage1::OnBnClickedTestproxy()
{
	// TODO: ڴӿؼ֪ͨ
	if (m_pTestProxy == NULL)
	{
		m_pTestProxy = GetGlobalProxyInstance();
		if(m_pTestProxy == NULL)
		{
			ATLTRACE("OnBnClickedTestproxy -> GetGlobalProxyInstance,  failed.\r\n");
			return;
		}
	}

	if(m_bIsTesting && m_pProxyTester)
	{
		m_pProxyTester->Release();
		m_pProxyTester = NULL;
		m_bIsTesting = FALSE;
		m_btnTest.SetWindowText(_T(""));
		m_staticTestProxy.SetWindowText(_T(""));
		return;
	}

	m_bIsTesting = FALSE;
	m_pProxyTester = m_pTestProxy->CreateTester();
	
	if (m_pProxyTester == NULL)
	{
		ATLTRACE("OnBnClickedTestproxy -> CreateTester failed.\r\n");
		return;
	}

	if (!GetSettings(&m_ProxyInfo))
	{
		MessageBox(_T("дȷ?"), 0, MB_ICONERROR);
		return;
	}

	PRCClient client;

	client.zero();
	client.sType = SOCK_STREAM;
	strcpy(client.szDomainName, "www.baidu.com");
	client.dstAddr.SetPort(80);

	if (!m_pProxyTester->Start(this, &client, &m_ProxyInfo))
	{
		ATLTRACE("OnBnClickedTestproxy -> Start failed.\r\n");
		return;
	}

	m_btnTest.SetWindowText(_T("ȡ"));
	m_bIsTesting = TRUE;

}

void CPage1::OnProxyTesterCallback(IProxyTester *pTester, int nErrorCode, WPARAM wParam, LPARAM lParam)
{
	ATLASSERT(pTester == m_pProxyTester);

	int nType = HIWORD(nErrorCode);
	int nCode = LOWORD(nErrorCode);

	CString szText;

	if (nType == LAYERCALLBACK_STATECHANGE)
	{
		if(nCode == connecting)
		{
			szText.Format(_T("Ӵ...."));
		}else if (nCode == connected)
		{
			szText.Format(_T("ӵʼЭ...."));
		}else
		{
			return;
		}
		m_staticTestProxy.SetWindowText(szText);

		return;
	}else if (nType == LAYERCALLBACK_LAYERSPECIFIC)
	{
		//رղԶ MessageBoxڲϢѭܵpTester¼
		pTester->Stop();

		if(nCode == 0)
		{
			szText = _T("");
			MessageBox(szText);
		}else
		{
			switch (nCode)
			{
			case PROXYERROR_NOCONN:
				szText.Format(_T("Ӵʧ"));
				break;
				/* fall through */
			case PROXYERROR_REQUESTFAILED:
				szText.Format(_T("Ŀ"));
				break;
			case PROXYERROR_AUTHREQUIRED:
				szText.Format(_T("Ҫ֤"));
				break;
			case PROXYERROR_AUTHTYPEUNKNOWN:
				szText.Format(_T("ִ֧֤ʽ"));
				break;
			case PROXYERROR_AUTHFAILED:
				szText.Format(_T("֤ʧ"));
				break;

			default:
				szText.Format(_T("ʹЭʧܣ: %d"), nCode);
				break;
			}
			MessageBox(szText);
		}

		pTester->Release();
		m_pProxyTester = NULL;
		m_btnTest.SetWindowText(_T(""));
		m_bIsTesting = FALSE;
		m_staticTestProxy.SetWindowText(_T(""));

	}

}