/************************************************************************/
/*    2007.12.22 LZX Created                                            */
/*                                                                      */
/*                                                                      */
/************************************************************************/

#include "stdafx.h"
#include "HookWinsock.h"
#include <psapi.h>
#include "GlobalProxy.h"

#pragma comment(lib,"psapi.lib")
#pragma comment(lib,"ws2_32.lib")

CHookWinsock *g_pHookWinsock = NULL;

CHookWinsock::CHookWinsock(void)
	: m_HackedSocket(this)
{
	m_bHookEnabled = FALSE;
	//
	ATLASSERT(g_pHookWinsock == NULL);

	g_pHookWinsock = this;

	m_ModuleName[HOOKMODULE_WS2_32] = "Ws2_32.dll";
	m_ModuleName[HOOKMODULE_KERNEL32] = "Kernel32.dll";
	m_szPRCPipeName = PRC_PIPESERVER_NAME;

	memset(&m_psi, 0, sizeof(m_psi));
}

CHookWinsock::~CHookWinsock(void)
{
	g_pHookWinsock = NULL;
}

void CHookWinsock::ZeroArray()
{
	ZeroMemory(m_FuncInCloneModule, sizeof(m_FuncInCloneModule));
	ZeroMemory(m_CloneModule, sizeof(m_CloneModule));
	ZeroMemory(m_HookedInfo, sizeof(m_HookedInfo));
	ZeroMemory(&m_psi, sizeof(m_psi));
}

CString CHookWinsock::GetLastError()
{
	return m_szLastError;
}

BOOL CHookWinsock::IsHookEnabled()
{
	return m_bHookEnabled;
}

BOOL CHookWinsock::EnableHook()
{
	ZeroArray();

	CPRCPipeClient PRCPipeClient;

	if(!PRCPipeClient.Connect(m_szPRCPipeName))
		return FALSE;

	if (! PRCPipeClient.PRCGetProxySettingsInfo(&m_psi))
	{
		return FALSE;
	}

	PRCPipeClient.Disconnect();

	//m_psi.bHookTCP = TRUE;
	//m_psi.bHookUDP = TRUE;
	//m_psi.nDNSOption = PSI_DNSOPT_LOCAL;
	//m_psi.bHookCreateProcess = TRUE;

	//hook API
	if (!HookWinsock())
	{
		return FALSE;
	}


	return TRUE;
}

BOOL CHookWinsock::DisableHook()
{
	UnhookWinsock();
	ZeroArray();

	return TRUE;
}

BOOL CHookWinsock::SetPRCPipeName(LPCSTR lpszPipeName)
{
	m_szPRCPipeName = lpszPipeName;
	return TRUE;
}

CString CHookWinsock::GetPRCPipeName()
{
	return m_szPRCPipeName;
}

BOOL CHookWinsock::HookWinsock()
{
	for(int i=0; i<HOOKMODULE_COUNT; i++)
	{
		if (!LoadLibraryA(m_ModuleName[i]))
			break;
	}

	do 
	{
		//copyһWs2_32 ȻHookAPIԭģָAPIڴjmp ָм亯 м亯copyģԵַ
		if(!CloneModule("Ws2_32.dll", &m_CloneModule[HOOKMODULE_WS2_32]))
			break;

		ATLTRACE("Ws2_32.dll : 0x%.8x | 0x%.8x", m_CloneModule[HOOKMODULE_WS2_32].pOldBaseAddr, m_CloneModule[HOOKMODULE_WS2_32].pNewBaseAddr);

		if(!HookAPI(HOOKMODULE_WS2_32, "connect", hook_connect, HOOKAPI_connect, FALSE))
			break;
		if(!HookAPI(HOOKMODULE_WS2_32, "gethostbyname", hook_gethostbyname, HOOKAPI_gethostbyname, FALSE))
			break;
		if(!HookAPI(HOOKMODULE_WS2_32, "WSAAsyncGetHostByName", hook_WSAAsyncGetHostByName, HOOKAPI_WSAAsyncGetHostByName, FALSE))
			break;
		if(!HookAPI(HOOKMODULE_WS2_32, "getaddrinfo", hook_getaddrinfo, HOOKAPI_getaddrinfo, FALSE))
			break;
		if(!HookAPI(HOOKMODULE_WS2_32, "getpeername", hook_getpeername, HOOKAPI_getpeername, FALSE))
			break;
		if(!HookAPI(HOOKMODULE_WS2_32, "closesocket", hook_closesocket, HOOKAPI_closesocket, FALSE))
			break;
		if(!HookAPI(HOOKMODULE_WS2_32, "sendto", hook_sendto, HOOKAPI_sendto, FALSE))
			break;
		if(!HookAPI(HOOKMODULE_WS2_32, "WSASendTo", hook_WSASendTo, HOOKAPI_WSASendTo, FALSE))
			break;
		if(!HookAPI(HOOKMODULE_WS2_32, "recvfrom", hook_recvfrom, HOOKAPI_recvfrom, FALSE))
			break;
		if(!HookAPI(HOOKMODULE_WS2_32, "WSARecvFrom", hook_WSARecvFrom, HOOKAPI_WSARecvFrom, FALSE))
			break;

		HookOnOff(HOOKAPI_connect, true);
		HookOnOff(HOOKAPI_gethostbyname, true);
		HookOnOff(HOOKAPI_WSAAsyncGetHostByName, true);
		HookOnOff(HOOKAPI_getaddrinfo, true);
		HookOnOff(HOOKAPI_getpeername, true);
		HookOnOff(HOOKAPI_closesocket, true);
		HookOnOff(HOOKAPI_sendto, true);
		HookOnOff(HOOKAPI_WSASendTo, true);
		HookOnOff(HOOKAPI_recvfrom, true);
		HookOnOff(HOOKAPI_WSARecvFrom, true);

		//
		//
		if (m_psi.bHookCreateProcess)
		{
			if(!CloneModule("Kernel32.dll", &m_CloneModule[HOOKMODULE_KERNEL32]))
				break;

			ATLTRACE("Kernel32.dll : 0x%.8x | 0x%.8x", m_CloneModule[HOOKMODULE_KERNEL32].pOldBaseAddr, m_CloneModule[HOOKMODULE_KERNEL32].pNewBaseAddr);

			if(!HookAPI(HOOKMODULE_KERNEL32, "CreateProcessInternalW", hook_CreateProcessInternalW, HOOKAPI_CreateProcessInternalW, FALSE))
				break;

			HookOnOff(HOOKAPI_CreateProcessInternalW, true);
		}


		m_bHookEnabled = TRUE;
		return TRUE;
	} while(FALSE);

	//!!!!

	m_szLastError = _T("ʼ HookWinsock ʧ.");

	return FALSE;
}

BOOL CHookWinsock::UnhookWinsock()
{
	m_bHookEnabled = FALSE;
	int i=0;
	for(i=0; i<HOOKAPI_COUNT; i++)
	{
		HookOnOff((eHOOKFUN)i, false);
	}

	for(i=0; i<HOOKMODULE_COUNT; i++)
	{
		free(m_CloneModule[i].pNewBaseAddr);
		m_CloneModule[i].pNewBaseAddr = NULL;
	}

	for(i=0; i<HOOKMODULE_COUNT; i++)
	{
		FreeLibrary((HMODULE)m_CloneModule[i].pOldBaseAddr);
		m_CloneModule[i].pOldBaseAddr = NULL;
	}

	return TRUE;
}

BOOL CHookWinsock::CloneModule(char *pszDll, CLONESTRUCT *pClone)
{
	MODULEINFO	modinfo;

	HMODULE hModule = GetModuleHandleA(pszDll);
	if(!hModule)
	{
		return FALSE;
	}
	if(!GetModuleInformation(GetCurrentProcess(), hModule, &modinfo, sizeof(MODULEINFO)))
	{
		return FALSE;
	}

	LPVOID lpClone = malloc(modinfo.SizeOfImage);
	if(!lpClone)
	{
		return FALSE;
	}
	memcpy(lpClone, modinfo.lpBaseOfDll, modinfo.SizeOfImage);

	DWORD flOldProtect;

	VirtualProtectEx(GetCurrentProcess(), lpClone, modinfo.SizeOfImage, PAGE_EXECUTE_READWRITE, &flOldProtect);

	pClone->pOldBaseAddr = hModule;
	pClone->pNewBaseAddr = lpClone;
	return TRUE;
}

void CHookWinsock::HookOnOff(eHOOKFUN ehf, bool DOUNT)
{
	HOOKSTRUCT *hookfunc = &m_HookedInfo[ehf];
	if (!hookfunc->funcaddr)
	{
		return;
	}

	HANDLE hProc = GetCurrentProcess();
	DWORD flOldProtect;
	VirtualProtectEx(hProc, hookfunc->funcaddr, DETOUR_TRAMPOLINE_SIZE, PAGE_READWRITE, &flOldProtect);

	if(DOUNT)
		WriteProcessMemory(hProc, hookfunc->funcaddr, hookfunc->newdata, DETOUR_TRAMPOLINE_SIZE, 0);
	else
		WriteProcessMemory(hProc, hookfunc->funcaddr, hookfunc->olddata, DETOUR_TRAMPOLINE_SIZE, 0);

	VirtualProtectEx(hProc, hookfunc->funcaddr, DETOUR_TRAMPOLINE_SIZE, flOldProtect, &flOldProtect);
}

BOOL CHookWinsock::HookAPI(eHOOKMODUDLE ehm, char *exportfunc, LPVOID myfuncaddr, eHOOKFUN ehf, BOOL bEnable)
{
	char *dllname = m_ModuleName[ehm];
	HOOKSTRUCT *hookfunc = &m_HookedInfo[ehf];

	HMODULE hModule = GetModuleHandleA(dllname);
	if(hModule == NULL)
		return FALSE;

	hookfunc->funcaddr = GetProcAddress(hModule, exportfunc);
	if(hookfunc->funcaddr == NULL)
		return FALSE;

	// Ҫhookĺַ Ӧcloneģ ַ
	m_FuncInCloneModule[ehf] = (FARPROC)((DWORD)m_HookedInfo[ehf].funcaddr - (DWORD)m_CloneModule[ehm].pOldBaseAddr + (DWORD)m_CloneModule[ehm].pNewBaseAddr);

	//save original data
	memcpy(hookfunc->olddata, hookfunc->funcaddr, DETOUR_TRAMPOLINE_SIZE);

	////long jmp
	////jmp
	//hookfunc->newdata[0] = 0xe9;
	////address
	//*(DWORD*)&hookfunc->newdata[1] = (DWORD)myfuncaddr - (DWORD)hookfunc->funcaddr - 5;

	if (hook_function_with_empty_trampoline((pbyte)m_FuncInCloneModule[ehf], (pbyte)hookfunc->funcaddr, (pbyte)myfuncaddr, NULL, NULL, NULL) != 0)
		return FALSE;

	//µĴ
	memcpy(hookfunc->newdata, hookfunc->funcaddr, DETOUR_TRAMPOLINE_SIZE);
	
	if (!bEnable)
	{
		HookOnOff(ehf, FALSE);
	}

	return TRUE;
}

BOOL CHookWinsock::IsHostNameReserved(const char *name)
{
	if(inet_addr(name) != INADDR_NONE)
		return TRUE;

	CPRCPipeClient PRCPipeClient;

	//ѯǷԴ, pipe server ʧ򷵻ֵΪ 
	if(!PRCPipeClient.Connect(m_szPRCPipeName))
		return TRUE;

	PRCClientInfo ci;
	ci.dwPid = GetCurrentProcessId();
	ci.dwTid = GetCurrentThreadId();

	BOOL bCan = PRCPipeClient.PRCCanProxyMe(&ci);

	PRCPipeClient.Disconnect();

	//ܴǱ
	return !bCan;
}

BOOL CHookWinsock::HackDNS(const char *name)
{
	if (m_psi.nDNSOption == PSI_DNSOPT_LOCAL)
	{
		return FALSE;
	}
	else if (m_psi.nDNSOption == PSI_DNSOPT_REMOTE)
	{
		return !IsHostNameReserved(name);
	}
	else
	{
		return FALSE;
	}
}

hostent* WSAAPI CHookWinsock::hook_gethostbyname(const char* name)
{
	return g_pHookWinsock->inhook_gethostbyname(name);
}

hostent* WSAAPI CHookWinsock::inhook_gethostbyname(const char* name)
{

	//жϽõĴֱַӵϵͳĽ

	if(HackDNS(name))
	{
		DWORD dummyIP = m_DummyDNS.GetDummyIP(name);

		return m_DummyDNS.GetHostent(dummyIP);
	}

	__gethostbyname pFunc = (__gethostbyname)m_FuncInCloneModule[HOOKAPI_gethostbyname];
	return pFunc(name);
}

HANDLE WSAAPI CHookWinsock::hook_WSAAsyncGetHostByName(HWND hWnd, unsigned int wMsg, const char* name, char* buf, int buflen)
{
	return g_pHookWinsock->inhook_WSAAsyncGetHostByName(hWnd, wMsg, name, buf, buflen);
}

HANDLE WSAAPI CHookWinsock::inhook_WSAAsyncGetHostByName(HWND hWnd, unsigned int wMsg, const char* name, char* buf, int buflen)
{
	if(HackDNS(name))
	{
		HANDLE hDummy = m_DummyDNS.GetDummyHandle(name, buf, buflen);
		::PostMessage(hWnd, wMsg, (WPARAM)hDummy, 0);
		return hDummy;
	}

	__WSAAsyncGetHostByName pFunc = (__WSAAsyncGetHostByName)m_FuncInCloneModule[HOOKAPI_WSAAsyncGetHostByName];
	return pFunc(hWnd, wMsg, name, buf, buflen);
}

int WSAAPI CHookWinsock::hook_getaddrinfo(IN const char FAR * nodename, IN const char FAR * servname, IN const struct addrinfo FAR * hints, OUT struct addrinfo FAR * FAR * res)
{
	return g_pHookWinsock->inhook_getaddrinfo(nodename, servname, hints, res);
}

int WSAAPI CHookWinsock::inhook_getaddrinfo(IN const char FAR * nodename, IN const char FAR * servname, IN const struct addrinfo FAR * hints, OUT struct addrinfo FAR * FAR * res)
{
	__getaddrinfo pFunc = (__getaddrinfo)m_FuncInCloneModule[HOOKAPI_getaddrinfo];
	int ret;

	if(!nodename)
		return pFunc(nodename, servname, hints, res);

	if(HackDNS(nodename))
	{
		DWORD dummyIP = m_DummyDNS.GetDummyIP(nodename);
		ret =  pFunc("127.0.0.1", servname, hints, res);
		struct addrinfo FAR *resls = *res;
		while(resls)
		{
			_SockAddr *pas = (_SockAddr*)resls->ai_addr;
			if(pas)
			{
				pas->SetIPLong(dummyIP);
			}
			resls = resls->ai_next;
		}
	}else
	{
		ret =  pFunc(nodename, servname, hints, res);
	}

	return ret;
}

int
WSAAPI
CHookWinsock::hook_connect(SOCKET s, const struct sockaddr FAR * name, int namelen)
{
	return g_pHookWinsock->inhook_connect(s, name, namelen);
}

int
WSAAPI
CHookWinsock::inhook_connect(SOCKET s, const struct sockaddr FAR * name, int namelen)
{
	_SockAddr addrname;

	addrname = *name;

	HackConnect(s, addrname);

	__connect pFunc = (__connect)m_FuncInCloneModule[HOOKAPI_connect];

	return pFunc(s, &addrname, namelen);
}

int
WSAAPI
CHookWinsock::hook_WSAConnect(SOCKET s, const struct sockaddr* name, int namelen, LPWSABUF lpCallerData, LPWSABUF lpCalleeData, LPQOS lpSQOS, LPQOS lpGQOS)
{
	return g_pHookWinsock->inhook_WSAConnect(s, name, namelen, lpCallerData, lpCalleeData, lpSQOS, lpGQOS);
}

int
WSAAPI
CHookWinsock::inhook_WSAConnect(SOCKET s, const struct sockaddr* name, int namelen, LPWSABUF lpCallerData, LPWSABUF lpCalleeData, LPQOS lpSQOS, LPQOS lpGQOS)
{
	_SockAddr addrname;

	addrname = *name;

	HackConnect(s, addrname);

	__WSAConnect pFunc = (__WSAConnect)m_FuncInCloneModule[HOOKAPI_WSAConnect];

	return pFunc(s, &addrname, namelen, lpCallerData, lpCalleeData, lpSQOS, lpGQOS);
}

BOOL CHookWinsock::HackConnect(SOCKET s, _SockAddr &addrname)
{
	if (! m_psi.bHookTCP)
		return FALSE;

	if(*(DWORD*)&addrname.sa_data[6] == 'pass' && *(DWORD*)&addrname.sa_data[10] == 'port')
	{
		*(DWORD*)&addrname.sa_data[6] = 0;
		*(DWORD*)&addrname.sa_data[10] = 0;
		return FALSE;
	}

	//check SO_REUSEADDR?
	int nSockType = SOCK_STREAM;
	int nTypeLen = sizeof(nSockType);
	if (getsockopt(s, SOL_SOCKET, SO_TYPE, (char*)&nSockType, &nTypeLen) != 0)
		return FALSE;

	ATLTRACE("HackConnect.getsockopt:SO_TYPE = %d\r\n", nSockType);

	if(nSockType != SOCK_DGRAM && nSockType != SOCK_STREAM)
		return FALSE;

	//??????????????
	if(nSockType == SOCK_DGRAM || addrname.GetdwIP() == 0x0100007f)
		return FALSE;

	_SockAddr srcAddr;
	int srcaddrlen = sizeof(_SockAddr);
	//ѯsocket󶨵ĵַ
	if(getsockname(s, &srcAddr, &srcaddrlen) == SOCKET_ERROR)
	{
		//δ֮, ²ѯ
		srcAddr.sa_family = AF_INET;
		srcAddr.SetIPLong(0);
		srcAddr.SetPort(0);
		if(bind(s, &srcAddr, sizeof(_SockAddr)) == SOCKET_ERROR)
			return FALSE;

		srcaddrlen = sizeof(_SockAddr);
		if(getsockname(s, &srcAddr, &srcaddrlen) == SOCKET_ERROR)
			return FALSE;
	}


	//ԭַ
	PRCClient prcc;
	prcc.zero();
	prcc.sType = nSockType;
	prcc.s = s;
	prcc.dwPid = GetCurrentProcessId();
	prcc.dwTid = GetCurrentThreadId();
	prcc.srcAddr = srcAddr;
	prcc.dstAddr = addrname;

	//õַͨdummyDNSȡõĻѯõԭ
	if(m_DummyDNS.IsDummyIP(addrname.GetdwIP()))
	{
		if(!m_DummyDNS.GetHostByIP(addrname.GetdwIP(), prcc.szDomainName, sizeof(prcc.szDomainName)))
		{
			//?
		}

	}


	CPRCPipeClient PRCPipeClient;

	//PRC ĵַϢ
	if(!PRCPipeClient.Connect(m_szPRCPipeName))
		return FALSE;

	PRCINFO prcinfo;
	if(!PRCPipeClient.GetPRCStartupInfo(&prcinfo))
	{
		PRCPipeClient.Disconnect();
		return FALSE;
	}

	if (!m_HackedSocket.CanHackIt(&prcc))
	{
		ATLTRACE("TCP: CHackedSocket.CanHackIt == FALSE\r\n");
		PRCPipeClient.Disconnect();
		return FALSE;
	}

	//ԭǼǵPRC
	if(!PRCPipeClient.PRCRegisterClient(&prcc))
	{
		PRCPipeClient.Disconnect();
		return FALSE;
	}

	PRCPipeClient.Disconnect();

	m_HackedSocket.push(&prcc);

	//޸ĿĵַΪPRC

	if (nSockType == SOCK_DGRAM)
	{
		addrname = prcc.udpAddr;
	}else
	{
		addrname = prcinfo.tcpaddr;
	}

	if(addrname.GetdwIP() == 0)
		addrname.SetIP("127.0.0.1");

#ifdef _DEBUG

	DWORD nIP = prcc.dstAddr.GetdwIP();
	const BYTE* pucIP = (BYTE*)&nIP;

	if(prcc.IsDNValid())
	{
		ATLTRACE("inhook_connect: connect to %s(%u.%u.%u.%u):%d\r\n", prcc.szDomainName, pucIP[0], pucIP[1], pucIP[2], pucIP[3], prcc.dstAddr.GetPort());
	}else
	{
		ATLTRACE("inhook_connect: connect to %u.%u.%u.%u:%d\r\n", pucIP[0], pucIP[1], pucIP[2], pucIP[3], prcc.dstAddr.GetPort());
	}

	nIP = addrname.GetdwIP();
	ATLTRACE("inhook_connect: redirect to %u.%u.%u.%u:%d\r\n", pucIP[0], pucIP[1], pucIP[2], pucIP[3], addrname.GetPort());
#endif

	return TRUE;
}

int WSAAPI CHookWinsock::hook_getpeername(SOCKET s, struct sockaddr* name, int* namelen)
{
	return g_pHookWinsock->inhook_getpeername(s, name, namelen);
}

int WSAAPI CHookWinsock::inhook_getpeername(SOCKET s, struct sockaddr* name, int* namelen)
{
	__getpeername pFunc = (__getpeername)m_FuncInCloneModule[HOOKAPI_getpeername];

	if (!m_psi.bHookTCP && !m_psi.bHookUDP)
	{
		return pFunc(s, name, namelen);
	}
	/*
	Ȳѯ׽Ƿ֮ǰ޸Ĺ
	֮ǰconnectԭĿaa.aa.aa.aa ȻHackConnect޸ΪPRCķַ, Ϊ˱getpeernameõPRCĵַҪ
	*/
	PRCClient prcc;
	if(m_HackedSocket.GetInfo(s, &prcc))
	{
		if(*namelen < sizeof(sockaddr))
		{
			WSASetLastError(WSAEFAULT);
			return SOCKET_ERROR;
		}
		*name = prcc.dstAddr;
		*namelen = sizeof(sockaddr);
		WSASetLastError(0);
		return 0;
	}else
	{
		return pFunc(s, name, namelen);
	}
}

int WSAAPI CHookWinsock::hook_closesocket(SOCKET s)
{
	return g_pHookWinsock->inhook_closesocket(s);
}

int WSAAPI CHookWinsock::inhook_closesocket(SOCKET s)
{
	__closesocket pFunc = (__closesocket)m_FuncInCloneModule[HOOKAPI_closesocket];

	if (!m_psi.bHookTCP && !m_psi.bHookUDP)
	{
		return pFunc(s);
	}

	do 
	{
		int nSockType = SOCK_STREAM;
		int nTypeLen = sizeof(nSockType);
		if (getsockopt(s, SOL_SOCKET, SO_TYPE, (char*)&nSockType, &nTypeLen) != 0)
			break;

		if(nSockType != SOCK_DGRAM && nSockType != SOCK_STREAM)
			break;

		if (m_HackedSocket.remove(s) > 0)
		{
			CPRCPipeClient PRCPipeClient;

			if(!PRCPipeClient.Connect(m_szPRCPipeName))
				break;

			PRCClient client;
			client.dwPid = GetCurrentProcessId();
			client.s = s;
			client.sType = nSockType;

			PRCPipeClient.PRCUnregisterClient(&client);

			PRCPipeClient.Disconnect();

		}

	} while(FALSE);

	return pFunc(s);
}

int WSAAPI CHookWinsock::hook_sendto(SOCKET s, const char* buf, int len, int flags, const struct sockaddr* to, int tolen)
{
	return g_pHookWinsock->inhook_sendto(s, buf, len, flags, to, tolen);
}

int WSAAPI CHookWinsock::hook_recvfrom(SOCKET s, char* buf, int len, int flags, struct sockaddr* from, int* fromlen)
{
	return g_pHookWinsock->inhook_recvfrom(s, buf, len, flags, from, fromlen);
}

int WSAAPI CHookWinsock::hook_WSASendTo(
						 SOCKET s,
						 LPWSABUF lpBuffers,
						 DWORD dwBufferCount,
						 LPDWORD lpNumberOfBytesSent,
						 DWORD dwFlags,
						 const struct sockaddr* lpTo,
						 int iToLen,
						 LPWSAOVERLAPPED lpOverlapped,
						 LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
						 )
{
	return g_pHookWinsock->inhook_WSASendTo(s, lpBuffers, dwBufferCount, lpNumberOfBytesSent, dwFlags, lpTo, iToLen, lpOverlapped, lpCompletionRoutine);
}

int WSAAPI CHookWinsock::hook_WSARecvFrom(
	SOCKET s,
	LPWSABUF lpBuffers,
	DWORD dwBufferCount,
	LPDWORD lpNumberOfBytesRecvd,
	LPDWORD lpFlags,
struct sockaddr* lpFrom,
	LPINT lpFromlen,
	LPWSAOVERLAPPED lpOverlapped,
	LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
	)
{
	return g_pHookWinsock->inhook_WSARecvFrom(s, lpBuffers, dwBufferCount, lpNumberOfBytesRecvd, lpFlags, lpFrom, lpFromlen, lpOverlapped, lpCompletionRoutine);
}

////////////////////

int WSAAPI CHookWinsock::inhook_sendto(SOCKET s, const char* buf, int len, int flags, const struct sockaddr* to, int tolen)
{
	if (! m_psi.bHookUDP)
	{
		__sendto pFunc = (__sendto)m_FuncInCloneModule[HOOKAPI_sendto];
		return pFunc(s, buf, len, flags, to, tolen);
	}

	WSABUF bufs;

	bufs.buf = (char FAR * )buf;
	bufs.len = len;

	DWORD dwNumberOfBytesSent = 0;
	int nRetVal = inhook_WSASendTo(s, &bufs, 1, &dwNumberOfBytesSent, flags, to, tolen, NULL, NULL);
	
	if(nRetVal == 0)
	{
		return (int)dwNumberOfBytesSent;
	}else
	{
		//SOCKET_ERROR
		return nRetVal;
	}

}

int WSAAPI CHookWinsock::inhook_WSASendTo(
							SOCKET s,
							LPWSABUF lpBuffers,
							DWORD dwBufferCount,
							LPDWORD lpNumberOfBytesSent,
							DWORD dwFlags,
							const struct sockaddr* lpTo,
							int iToLen,
							LPWSAOVERLAPPED lpOverlapped,
							LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
							)
{
	__WSASendTo pFunc = (__WSASendTo)m_FuncInCloneModule[HOOKAPI_WSASendTo];

	if (! m_psi.bHookUDP)
	{
		return pFunc(s, lpBuffers, dwBufferCount, lpNumberOfBytesSent, dwFlags, lpTo, iToLen, lpOverlapped, lpCompletionRoutine);
	}

	_SockAddr addrname;

	addrname = *lpTo;

	PRCClient prcc;

	if (!HackSendTo(s, addrname, &prcc))
	{
		return pFunc(s, lpBuffers, dwBufferCount, lpNumberOfBytesSent, dwFlags, lpTo, iToLen, lpOverlapped, lpCompletionRoutine);
	}


	DWORD nBufLenAdded = 0;
	char hdr[0xff+8];
	memset(hdr, 0, sizeof(hdr));
	WSABUF wsabuf[32];
	DWORD bufidx = 0;

	if(prcc.IsDNValid())
	{
		const char* pszAsciiProxyPeerHost = prcc.szDomainName;
		int iLenAsciiProxyPeerHost = strlen(pszAsciiProxyPeerHost);

		//ATYP
		hdr[3] = 0x03;
		//DST.ADDR
		int nHdrLen = 4;
		hdr[nHdrLen++] = (char)iLenAsciiProxyPeerHost;
		memcpy(&hdr[nHdrLen], pszAsciiProxyPeerHost, iLenAsciiProxyPeerHost);
		nHdrLen += iLenAsciiProxyPeerHost;
		//DST.PORT
		*(WORD*)&hdr[nHdrLen] = (WORD)htons((u_short)prcc.dstAddr.GetPort());
		nHdrLen += 2;

		wsabuf[bufidx].buf = hdr;
		wsabuf[bufidx].len = nHdrLen;
		bufidx++;

		nBufLenAdded = nHdrLen;

		//
		for(DWORD i=0 ; bufidx<32 && i<dwBufferCount; bufidx++, i++)
		{
			wsabuf[bufidx].buf = lpBuffers[i].buf;
			wsabuf[bufidx].len = lpBuffers[i].len;
		}

	}else
	{
		//ATYP
		hdr[3] = 0x01;
		//DST.ADDR
		int nHdrLen = 4;
		*(DWORD*)&hdr[nHdrLen] = prcc.dstAddr.GetdwIP();
		nHdrLen += 4;
		//DST.PORT
		*(WORD*)&hdr[nHdrLen] = (WORD)htons((u_short)prcc.dstAddr.GetPort());
		nHdrLen += 2;

		wsabuf[bufidx].buf = hdr;
		wsabuf[bufidx].len = nHdrLen;
		bufidx++;

		nBufLenAdded = nHdrLen;

		//
		for(DWORD i=0 ; bufidx<32 && i<dwBufferCount; bufidx++, i++)
		{
			wsabuf[bufidx].buf = lpBuffers[i].buf;
			wsabuf[bufidx].len = lpBuffers[i].len;
		}
	}

	int nRetVal = pFunc(s, wsabuf, bufidx, lpNumberOfBytesSent, dwFlags, &addrname, iToLen, lpOverlapped, lpCompletionRoutine);

	if(nRetVal == 0 && nBufLenAdded > 0 && *lpNumberOfBytesSent > nBufLenAdded)
	{
		*lpNumberOfBytesSent -= nBufLenAdded;
	}

	return nRetVal;
}

int WSAAPI CHookWinsock::inhook_recvfrom(SOCKET s, char* buf, int len, int flags, struct sockaddr* from, int* fromlen)
{
	if (! m_psi.bHookUDP)
	{
		__recvfrom pFunc = (__recvfrom)m_FuncInCloneModule[HOOKAPI_recvfrom];
		return pFunc(s, buf, len, flags, from, fromlen);
	}

	WSABUF bufs;

	bufs.buf = (char FAR * )buf;
	bufs.len = len;

	int nRetVal;
	DWORD dwNumberOfBytesRecvd = 0;

	nRetVal = inhook_WSARecvFrom(s, &bufs, 1, &dwNumberOfBytesRecvd, (LPDWORD)&flags, from, fromlen, NULL, NULL);

	if(nRetVal == 0)
	{
		return (int)dwNumberOfBytesRecvd;
	}

	return nRetVal;

//
//	int ret = pFunc(s, buf, len, flags, from, fromlen);
//
//	if(ret > 0)
//	{
//#ifdef _DEBUG
//		in_addr *pAddr = ((_SockAddr*)from)->GetAddr();
//		ATLTRACE("recvfrom1: %u.%u.%u.%u:%d\r\n", pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, ((_SockAddr*)from)->GetPort());
//#endif
//
//		if (m_HackedSocket.ReplaceAddr(s, (_SockAddr *)from))
//		{
//#ifdef _DEBUG
//			pAddr = ((_SockAddr*)from)->GetAddr();
//			ATLTRACE("recvfrom2: %u.%u.%u.%u:%d\r\n", pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, ((_SockAddr*)from)->GetPort());
//#endif
//		}
//	}
//
//	return ret;
}


int WSAAPI CHookWinsock::inhook_WSARecvFrom(
							  SOCKET s,
							  LPWSABUF lpBuffers,
							  DWORD dwBufferCount,
							  LPDWORD lpNumberOfBytesRecvd,
							  LPDWORD lpFlags,
								struct sockaddr* lpFrom,
									LPINT lpFromlen,
									LPWSAOVERLAPPED lpOverlapped,
									LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
									)
{
	__WSARecvFrom pFunc = (__WSARecvFrom)m_FuncInCloneModule[HOOKAPI_WSARecvFrom];

	if (! m_psi.bHookUDP)
	{
		return pFunc(s, lpBuffers, dwBufferCount, lpNumberOfBytesRecvd, lpFlags, lpFrom, lpFromlen, lpOverlapped, lpCompletionRoutine);
	}

	WSABUF wsabuf[32];
	DWORD bufidx = 0;

	char hdr[10];
	memset(hdr, 0, 10);
	//
	wsabuf[0].buf = hdr;
	wsabuf[0].len = 10;

	bufidx++;

	for(DWORD i=0 ; bufidx<32 && i<dwBufferCount; bufidx++, i++)
	{
		wsabuf[bufidx].buf = lpBuffers[i].buf;
		wsabuf[bufidx].len = lpBuffers[i].len;
	}

	int nRetVal = pFunc(s, wsabuf, bufidx, lpNumberOfBytesRecvd, lpFlags, lpFrom, lpFromlen, lpOverlapped, lpCompletionRoutine);

	if (nRetVal == 0)
	{
		if(*lpNumberOfBytesRecvd > 10)
		{
			*lpNumberOfBytesRecvd -= 10;

			bufidx = 1;
			for(DWORD i=0 ; bufidx<32 && i<dwBufferCount; bufidx++, i++)
			{
				lpBuffers[i].buf = wsabuf[bufidx].buf; 
				lpBuffers[i].len = wsabuf[bufidx].len;
			}


#ifdef _DEBUG
			in_addr *pAddr = ((_SockAddr*)lpFrom)->GetAddr();
			ATLTRACE("inhook_WSARecvFrom1: %u.%u.%u.%u:%d\r\n", pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, ((_SockAddr*)lpFrom)->GetPort());
#endif

			if (!m_HackedSocket.ReplaceAddr(s, (_SockAddr *)lpFrom, *(DWORD*)&hdr[4], *(WORD*)&hdr[8]))
			{
				//ܰԴPRC
				//
				ATLTRACE("m_HackedSocket.ReplaceAddr(%d, ...) == FALSE\r\n", s);
				WSASetLastError(WSAEWOULDBLOCK);
				return SOCKET_ERROR;
			}
#ifdef _DEBUG
			pAddr = ((_SockAddr*)lpFrom)->GetAddr();
			ATLTRACE("inhook_WSARecvFrom2: %u.%u.%u.%u:%d\r\n", pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, ((_SockAddr*)lpFrom)->GetPort());
#endif

		}else
		{
			//
			WSASetLastError(WSAEWOULDBLOCK);
			return SOCKET_ERROR;
		}
	}

	return nRetVal;


//	int ret = pFunc(s, lpBuffers, dwBufferCount, lpNumberOfBytesRecvd, lpFlags, lpFrom, lpFromlen, lpOverlapped, lpCompletionRoutine);
//
//	if(ret == 0)
//	{
//#ifdef _DEBUG
//		in_addr *pAddr = ((_SockAddr*)lpFrom)->GetAddr();
//		ATLTRACE("recvfrom1: %u.%u.%u.%u:%d\r\n", pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, ((_SockAddr*)lpFrom)->GetPort());
//#endif
//
//		if (m_HackedSocket.ReplaceAddr(s, (_SockAddr *)lpFrom))
//		{
//#ifdef _DEBUG
//			pAddr = ((_SockAddr*)lpFrom)->GetAddr();
//			ATLTRACE("recvfrom2: %u.%u.%u.%u:%d\r\n", pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, ((_SockAddr*)lpFrom)->GetPort());
//#endif
//		}
//	}


	//return ret;
}


BOOL CHookWinsock::HackSendTo(SOCKET s, _SockAddr &addrname, LPPRCClient lpC)
{
	if (!m_psi.bHookUDP)
		return FALSE;

	if(*(DWORD*)&addrname.sa_data[6] == 'pass' && *(DWORD*)&addrname.sa_data[10] == 'port')
	{
		*(DWORD*)&addrname.sa_data[6] = 0;
		*(DWORD*)&addrname.sa_data[10] = 0;
		return FALSE;
	}

	int nSockType;
	int nTypeLen = sizeof(nSockType);
	if (getsockopt(s, SOL_SOCKET, SO_TYPE, (char*)&nSockType, &nTypeLen) != 0)
		return FALSE;

	if (nSockType != SOCK_DGRAM)
		return FALSE;

	_SockAddr srcAddr;
	int srcaddrlen = sizeof(_SockAddr);
	//ѯsocket󶨵ĵַ
	if(getsockname(s, &srcAddr, &srcaddrlen) == SOCKET_ERROR)
	{
		return FALSE;
	}

	PRCClient prcc;
	prcc.zero();
	prcc.sType = SOCK_DGRAM;
	prcc.s = s;
	prcc.dwPid = GetCurrentProcessId();
	prcc.dwTid = GetCurrentThreadId();
	prcc.srcAddr = srcAddr;
	prcc.dstAddr = addrname;

	//õַͨdummyDNSȡõĻѯõԭ
	if(m_DummyDNS.IsDummyIP(addrname.GetdwIP()))
	{
		if(!m_DummyDNS.GetHostByIP(addrname.GetdwIP(), prcc.szDomainName, sizeof(prcc.szDomainName)))
		{
			//?
		}

	}

	//Ѿhacked prcc.udpAddr תudpķַ
	if (m_HackedSocket.IsUDPReqHacked(&prcc))
	{
		addrname = prcc.udpAddr;
		if(addrname.GetdwIP() == 0)
			addrname.SetIP("127.0.0.1");

		*lpC = prcc;

#ifdef _DEBUG
		in_addr *pAddr = addrname.GetAddr();
		if (prcc.IsDNValid())
		{
			ATLTRACE("sendto1: socket:%d: %s(%u.%u.%u.%u):%d\r\n", s, prcc.szDomainName, pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, addrname.GetPort());
		}else
		{
			ATLTRACE("sendto1: socket:%d: %u.%u.%u.%u:%d\r\n", s, pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, addrname.GetPort());
		}
#endif

		return TRUE;
	}

	if (!m_HackedSocket.CanHackIt(&prcc))
	{
		ATLTRACE("UDP: CHackedSocket.CanHackIt == FALSE\r\n");
		return FALSE;
	}

	CPRCPipeClient PRCPipeClient;

	//PRC ĵַϢ
	if(!PRCPipeClient.Connect(m_szPRCPipeName))
		return FALSE;

	if (! PRCPipeClient.PRCRegisterClient(&prcc))
	{
		return FALSE;
	}

	PRCPipeClient.Disconnect();

#ifdef _DEBUG
	in_addr *pAddr = addrname.GetAddr();
	if (prcc.IsDNValid())
	{
		ATLTRACE("sendto1: socket:%d: %s(%u.%u.%u.%u):%d\r\n", s, prcc.szDomainName, pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, addrname.GetPort());
	}else
	{
		ATLTRACE("sendto1: socket:%d: %u.%u.%u.%u:%d\r\n", s, pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, addrname.GetPort());
	}
#endif

	addrname = prcc.udpAddr;


	m_HackedSocket.push(&prcc);

	if(addrname.GetdwIP() == 0)
		addrname.SetIP("127.0.0.1");

	*lpC = prcc;

#ifdef _DEBUG
	pAddr = addrname.GetAddr();
	ATLTRACE("sendto2: socket:%d: %u.%u.%u.%u:%d\r\n", s, pAddr->s_net, pAddr->s_host, pAddr->s_lh, pAddr->s_impno, addrname.GetPort());
#endif

	return TRUE;
}


BOOL WINAPI CHookWinsock::hook_CreateProcessInternalW(HANDLE hToken, LPCWSTR lpApplicationName, LPWSTR lpCommandLine, LPSECURITY_ATTRIBUTES lpProcessAttributes, LPSECURITY_ATTRIBUTES lpThreadAttributes, BOOL bInheritHandles, DWORD dwCreationFlags, LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory, LPSTARTUPINFOW lpStartupInfo, LPPROCESS_INFORMATION lpProcessInformation, PHANDLE hNewToken)
{
	return g_pHookWinsock->inhook_CreateProcessInternalW(hToken, lpApplicationName, lpCommandLine, lpProcessAttributes, lpThreadAttributes, bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory, lpStartupInfo, lpProcessInformation, hNewToken);
}

BOOL WINAPI CHookWinsock::inhook_CreateProcessInternalW(HANDLE hToken, LPCWSTR lpApplicationName, LPWSTR lpCommandLine, LPSECURITY_ATTRIBUTES lpProcessAttributes, LPSECURITY_ATTRIBUTES lpThreadAttributes, BOOL bInheritHandles, DWORD dwCreationFlags, LPVOID lpEnvironment, LPCWSTR lpCurrentDirectory, LPSTARTUPINFOW lpStartupInfo, LPPROCESS_INFORMATION lpProcessInformation, PHANDLE hNewToken)
{
	__CreateProcessInternalW pFunc = (__CreateProcessInternalW)m_FuncInCloneModule[HOOKAPI_CreateProcessInternalW];

	if (! m_psi.bHookCreateProcess)
	{
		return pFunc(hToken, lpApplicationName, lpCommandLine, lpProcessAttributes, lpThreadAttributes, bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory, lpStartupInfo, lpProcessInformation, hNewToken);
	}

	//û־̣߳ ޸֮
	BOOL bSuspend;
	if ((dwCreationFlags & CREATE_SUSPENDED) == 0)
	{
		dwCreationFlags |= CREATE_SUSPENDED;
		bSuspend = TRUE;
	}else
	{
		bSuspend = FALSE;
	}

	BOOL bRetVal = pFunc(hToken, lpApplicationName, lpCommandLine, lpProcessAttributes, lpThreadAttributes, bInheritHandles, dwCreationFlags, lpEnvironment, lpCurrentDirectory, lpStartupInfo, lpProcessInformation, hNewToken);

	if(bRetVal)
	{
		do 
		{
			CPRCPipeClient PRCPipeClient;
			if(!PRCPipeClient.Connect(m_szPRCPipeName))
				break;

			HookNewProcessInfo hnpi;

			if (lpApplicationName)
			{
				wcsncpy(hnpi.szAppPath, lpApplicationName, MAX_PATH);
			}
			if (lpCommandLine)
			{
				wcsncpy(hnpi.szCommandLine, lpCommandLine, MAX_PATH);
			}
			hnpi.pi = *lpProcessInformation;
			if (! PRCPipeClient.PRCNotifyNewProcess(&hnpi))
			{
				break;
			}

			PRCPipeClient.Disconnect();

		} while(FALSE);

		//Ǳ޸ĵ֪ͨPRCظ
		if (bSuspend)
		{
			ResumeThread(lpProcessInformation->hThread);
		}
	}


	return bRetVal;
}