#pragma once


#include "structinfo.h"
#include "TSSTL.h"
#include "PRCPipeClient.h"
#include "inline_hook.h"

using namespace std;

typedef enum
{
	HOOKMODULE_WS2_32 = 0,
	HOOKMODULE_KERNEL32,
	HOOKMODULE_COUNT
}eHOOKMODUDLE;

//getaddrinfo
typedef enum
{
	HOOKAPI_connect = 0,
	HOOKAPI_WSAConnect,
	HOOKAPI_gethostbyname,
	HOOKAPI_WSAAsyncGetHostByName,
	HOOKAPI_getaddrinfo,
	HOOKAPI_getpeername,
	HOOKAPI_closesocket,
	HOOKAPI_sendto,
	HOOKAPI_WSASendTo,
	HOOKAPI_recvfrom,
	HOOKAPI_WSARecvFrom,

	//kernel32
	HOOKAPI_CreateProcessInternalW,

	HOOKAPI_COUNT
}eHOOKFUN; 

class CGlobalProxy;

class CAsyncSocketExLayer;

class CHookWinsock
{
	friend CAsyncSocketExLayer;

	

	//hook info struct
	typedef struct
	{
		LPVOID pOldBaseAddr;
		LPVOID pNewBaseAddr;
	}CLONESTRUCT;

	typedef struct
	{
		FARPROC funcaddr;
		BYTE    olddata[DETOUR_TRAMPOLINE_SIZE];
		BYTE    newdata[DETOUR_TRAMPOLINE_SIZE];
	}HOOKSTRUCT;

	//

	typedef struct  
	{
		char name[MAX_PATH];

		operator char*() 
		{ 
			return &name[0];
		}

		char * operator =(char *lpsz)
		{
			int i=0;

			while(i<sizeof(name)-1 && lpsz[i])
			{
				name[i] = lpsz[i];
				i++;
			}
			name[i] = '\0';
			return name;
		}
	}MODULENAME;


	//CDummyDNS start

	//̵dns Ȼ󷵻һƵip
	//Ƶip֮connect ֮Ĵԭȥ
	class CDummyDNS
	{
	public:
		typedef struct
		{
			DWORD dummyIP;
			char szHost[50];
		}INFO;

		CDummyDNS()
		{
			//127.255.0.0
			m_DummyIP = 0x7fff0000;
			m_DummyHandle = 0x520307;
		}

		~CDummyDNS()
		{

		}

		BOOL IsDummyIP(DWORD dwip)
		{
			return (ntohl(dwip) >> 16) == 0x7fff;//127.255.x.x
		}

		HANDLE GetDummyHandle(const char* name, char* buf, int buflen)
		{
			if(m_DummyHandle > 0xffff0000)
				m_DummyHandle = 0x520307;

			DWORD dummyip = GetDummyIP(name);
			buflen = min(sizeof(hostent), buflen);
			memcpy(buf, GetHostent(dummyip), buflen);

			return (HANDLE)m_DummyHandle++;
		}

		DWORD GetDummyIP(const char *lpHost)
		{
			INFO *pNode = GetNode(lpHost);
			if(pNode)
				return pNode->dummyIP;

			CTSList<INFO>::critical lc = m_ls;
			m_DummyIP++;
			if(m_DummyIP > 0x7ffffffe)
				m_DummyIP = 0x7fff0000;

			INFO info;
			info.dummyIP = htonl(m_DummyIP);
			strncpy(info.szHost, lpHost, sizeof(info.szHost));

			m_ls.push_front(info);

			return htonl(m_DummyIP);
		}

		BOOL GetHostByIP(DWORD dummyip, char *lpbuf, int bufsize)
		{
			CTSList<INFO>::critical lc = m_ls;
			for(list<INFO>::iterator it=m_ls.begin(); it!=m_ls.end(); it++)
			{
				if((*it).dummyIP == dummyip)
				{
					strncpy(lpbuf, (*it).szHost, bufsize);
					return TRUE;
				}
			}
			return FALSE;
		};

		hostent *GetHostent(DWORD nIP)
		{
			hostent *p = gethostbyname("127.0.0.1");
			//????
			if (p)
			{
				*(DWORD*)p->h_addr_list[0] = nIP;
			}
			return p;
			//m_ht = *p;
			//*(DWORD*)(m_ht.h_addr_list[0]) = nIP;
			//return &m_ht;
		};

		INFO *GetNode(const char *name)
		{
			CTSList<INFO>::critical lc = m_ls;
			for(list<INFO>::iterator it=m_ls.begin(); it!=m_ls.end(); it++)
			{
				if(_stricmp(name, it->szHost) == 0)
					return &*it;
			}
			return NULL;
		}

		//BOOL RemoveNode();

	private:

		char hoststruct[MAXGETHOSTSTRUCT];
		hostent m_ht;
		DWORD m_DummyIP;
		DWORD m_DummyHandle;
		CTSList<INFO> m_ls;
	};//CDummyDNS end

	class CHackedSocket
	{
	public:
		CHackedSocket(CHookWinsock *pHW)
		{
			m_pHW = pHW;
		}
		~CHackedSocket()
		{

		}

		typedef PRCClient CONNINFO;

		void push(CONNINFO *pCI)
		{
			CTSList<CONNINFO>::critical lc = m_ls;

			m_ls.push_front(*pCI);
		}

		int remove(SOCKET s)
		{
			int nCount = 0;
			CTSList<CONNINFO>::critical lc = m_ls;

			for(CTSList<CONNINFO>::iterator it=m_ls.begin(); it!=m_ls.end();)
			{
				if(it->s == s)
				{
					m_ls.erase(it++);
					nCount++;
				}else
				{
					it++;
				}
			}
			
			return nCount;
		}

		BOOL GetInfo(SOCKET s, CONNINFO *pCI)
		{
			CTSList<CONNINFO>::critical lc = m_ls;

			for(CTSList<CONNINFO>::iterator it=m_ls.begin(); it!=m_ls.end(); it++)
			{
				if(it->s == s)
				{
					*pCI = *it;
					return TRUE;
				}
			}
			return FALSE;
		}

		BOOL CanHackIt(const LPPRCClient pCI)
		{
			CTSList<CONNINFO>::critical lc = m_ls;

			if (!m_PRCPipeClient.IsConnected())
			{
				ATLTRACE("CHackedSocket.m_PRCPipeClient is connecting.\r\n");
				if (!m_PRCPipeClient.Connect(m_pHW->GetPRCPipeName()))
				{
					ATLTRACE("CHackedSocket.m_PRCPipeClient Failed to connect to PRCPipeServer.\r\n");
					return FALSE;
				}
			}

			ProxyInfo pi;
			if (!m_PRCPipeClient.PRCGetProxyInfo((LPPRCClient)pCI, &pi))
			{
				return FALSE;
			}

			if (m_PRCPipeClient.GetLastError() != 0)
			{
				ATLTRACE("CHackedSocket.m_PRCPipeClient GetLastError == %d\r\n", m_PRCPipeClient.GetLastError());
				m_PRCPipeClient.Disconnect();
				return FALSE;
			}

			if (pCI->IsDNValid())
			{
				return TRUE;
			}

			//Ҫʱؾ磬Ǵǹģ򲻽ٳsocket
			in_addr dstaddr;
			in_addr proxyaddr;

			dstaddr.s_addr = pCI->dstAddr.GetdwIP();
			proxyaddr.s_addr = inet_addr(pi.strProxyHost);

			if (!dstaddr.s_addr || dstaddr.s_addr == INADDR_NONE || !proxyaddr.s_addr|| dstaddr.s_addr == INADDR_NONE )
			{
				return FALSE;
			}

			if (dstaddr.s_net == 127)
			{
				if (proxyaddr.s_net != 127)
				{
					return FALSE;
				}
			}else if (dstaddr.s_net == 192 && dstaddr.s_host == 168)
			{
				if (proxyaddr.s_net != dstaddr.s_net || proxyaddr.s_host != dstaddr.s_host || proxyaddr.s_lh != dstaddr.s_lh)
				{
					return FALSE;
				}
			}else if (dstaddr.s_net == 172 && dstaddr.s_host >= 16 && dstaddr.s_host <= 131)
			{
				if (proxyaddr.s_net != dstaddr.s_net || proxyaddr.s_host != dstaddr.s_host || proxyaddr.s_lh != dstaddr.s_lh)
				{
					return FALSE;
				}
			}else if (dstaddr.s_net == 10)
			{
				if (proxyaddr.s_net != dstaddr.s_net || proxyaddr.s_host != dstaddr.s_host || proxyaddr.s_lh != dstaddr.s_lh)
				{
					return FALSE;
				}
			}

			return TRUE;
		}

		BOOL IsUDPReqHacked(const CONNINFO *pCI)
		{
			CTSList<CONNINFO>::critical lc = m_ls;

			//м¼нٳֹudpĿͻϢ
			for (CTSList<CONNINFO>::iterator it=m_ls.begin(); it!=m_ls.end(); it++)
			{
				if(it->s == pCI->s && it->sType == SOCK_DGRAM)
				{
					//жԭַǷһ
					if ( it->srcAddr.GetPort() != ((LPPRCClient)pCI)->srcAddr.GetPort()
						|| (it->srcAddr.GetdwIP() != 0 && it->srcAddr.GetdwIP() != ((LPPRCClient)pCI)->srcAddr.GetdwIP())
						)
						continue;//ǰڵϢһ£ ȷûٳֹsocket ڵ

					//UDPڱһַַ ԿԲжĿIPȷϸudpsocketǷٳֹ
					//ĿĵַĻ ΪհʱַΪdummyIP һµҪشudp˿
					//һʾudp socketѾhijacked
					if (((LPPRCClient)pCI)->IsDNValid())
					{
						//if (it->dstAddr.GetPort() != ((LPPRCClient)pCI)->dstAddr.GetPort()
						//	|| _stricmp(it->szDomainName, ((LPPRCClient)pCI)->szDomainName))
						//	continue;
						if (!it->IsDNValid())
							continue;

						if (_stricmp(it->szDomainName, ((LPPRCClient)pCI)->szDomainName) != 0)
							continue;

					}

					if (!m_PRCPipeClient.IsConnected())
					{
						ATLTRACE("CHackedSocket.m_PRCPipeClient is connecting.\r\n");
						if (!m_PRCPipeClient.Connect(m_pHW->GetPRCPipeName()))
						{
							ATLTRACE("CHackedSocket.m_PRCPipeClient Failed to connect to PRCPipeServer.\r\n");
							return FALSE;
						}
					}

					UDPLocalProxyAddrInfo udpai;
					udpai.clientip = it->srcAddr.GetdwIP();
					udpai.clientport = it->srcAddr.GetPort();
					udpai.proxyport = it->udpAddr.GetPort();

					BOOL bState = m_PRCPipeClient.PRCGetUDPClientPortState(&udpai);

					if (m_PRCPipeClient.GetLastError() != 0)
					{
						ATLTRACE("CHackedSocket.m_PRCPipeClient GetLastError == %d. state: %d\r\n", m_PRCPipeClient.GetLastError(), bState);
						m_PRCPipeClient.Disconnect();
						return FALSE;
					}

					if (!bState)
					{
						ATLTRACE("CHackedSocket.m_PRCPipeClient.PRCGetUDPClientPortState == FALSE\r\n");
						m_ls.erase(it);
						return FALSE;
					}

					((LPPRCClient)pCI)->udpAddr = it->udpAddr;

					return TRUE;
				}
			}
			return FALSE;
		}

		//ڽպ  Դַ
		//dwIPPortudpͷеĵַϢ
		//PRCİ ҪԴַΪdwIPPort
		BOOL ReplaceAddr(SOCKET s, _SockAddr* from, DWORD dwIP, WORD Port)
		{
			_SockAddr srcAddr;
			int srcaddrlen = sizeof(_SockAddr);
			//ѯsocket󶨵ĵַ
			if(getsockname(s, &srcAddr, &srcaddrlen) == SOCKET_ERROR)
			{
				return FALSE;
			}

			CTSList<CONNINFO>::critical lc = m_ls;

			for (CTSList<CONNINFO>::iterator it=m_ls.begin(); it!=m_ls.end(); it++)
			{
				if(it->s == s)
				{
					if (it->srcAddr.GetPort() != srcAddr.GetPort()
						|| (it->srcAddr.GetdwIP() != 0 && it->srcAddr.GetdwIP() != srcAddr.GetdwIP())
						)
						continue;

					//ȷPRCģudpAddrǱudpĵַ
					if (from->GetPort() != it->udpAddr.GetPort()
						|| (it->udpAddr.GetdwIP() != 0 && it->udpAddr.GetdwIP() != from->GetdwIP())
						)
					{
						continue;
					}

					//жϿͻ˷ʱĿĵַIP
					if (it->IsDNValid())
					{
						//
						//ѵַΪ dummyIP!
						from->SetIPLong(it->dstAddr.GetdwIP());
						from->SetPort(ntohs(Port));
						return TRUE;
					}else
					{
						//IP
						//udpͷIPϢȥ
						from->SetIPLong(dwIP);
						from->SetPort(ntohs(Port));
						return TRUE;
					}

				}
			}

			//PRC

			return FALSE;
		}



	private:
		CTSList<CONNINFO> m_ls;
		CPRCPipeClient m_PRCPipeClient;
		CHookWinsock *m_pHW;

	};



public:
	CHookWinsock(void);
	~CHookWinsock(void);

	CString GetLastError();

	BOOL IsHookEnabled();
	BOOL EnableHook();
	BOOL DisableHook();

	BOOL SetPRCPipeName(LPCSTR lpszPipeName);
	CString GetPRCPipeName();

protected:

	BOOL HookWinsock();
	BOOL UnhookWinsock();

	BOOL CloneModule(char *pszDll, CLONESTRUCT *pClone);
	void HookOnOff(eHOOKFUN ehf, bool DOUNT);
	BOOL HookAPI(eHOOKMODUDLE ehm, char *exportfunc, LPVOID myfuncaddr, eHOOKFUN ehf, BOOL bEnable);

	BOOL IsHostNameReserved(const char *name);
	void ZeroArray();

	//dnsļAPI
	static hostent* WSAAPI hook_gethostbyname(const char* name);
	hostent* WSAAPI inhook_gethostbyname(const char* name);

	static HANDLE WSAAPI hook_WSAAsyncGetHostByName(HWND hWnd, unsigned int wMsg, const char* name, char* buf, int buflen);
	HANDLE WSAAPI inhook_WSAAsyncGetHostByName(HWND hWnd, unsigned int wMsg, const char* name, char* buf, int buflen);

	static int WSAAPI hook_getaddrinfo(IN const char FAR * nodename, IN const char FAR * servname, IN const struct addrinfo FAR * hints, OUT struct addrinfo FAR * FAR * res);
	int WSAAPI inhook_getaddrinfo(IN const char FAR * nodename, IN const char FAR * servname, IN const struct addrinfo FAR * hints, OUT struct addrinfo FAR * FAR * res);

	//ӵAPI
	static int WSAAPI hook_connect(SOCKET s, const struct sockaddr FAR * name, int namelen);
	int WSAAPI inhook_connect(SOCKET s, const struct sockaddr FAR * name, int namelen);

	static int WSAAPI hook_WSAConnect(SOCKET s, const struct sockaddr* name, int namelen, LPWSABUF lpCallerData, LPWSABUF lpCalleeData, LPQOS lpSQOS, LPQOS lpGQOS);
	int WSAAPI inhook_WSAConnect(SOCKET s, const struct sockaddr* name, int namelen, LPWSABUF lpCallerData, LPWSABUF lpCalleeData, LPQOS lpSQOS, LPQOS lpGQOS);

	//
	BOOL HackConnect(SOCKET s, _SockAddr &addrname);

	//
	BOOL HackDNS(const char *name);

	static int WSAAPI hook_getpeername(SOCKET s, struct sockaddr* name, int* namelen);
	int WSAAPI inhook_getpeername(SOCKET s, struct sockaddr* name, int* namelen);

	static int WSAAPI hook_closesocket(SOCKET s);
	int WSAAPI inhook_closesocket(SOCKET s);

	static int WSAAPI hook_sendto(SOCKET s, const char* buf, int len, int flags, const struct sockaddr* to, int tolen);
	int WSAAPI inhook_sendto(SOCKET s, const char* buf, int len, int flags, const struct sockaddr* to, int tolen);

	static int WSAAPI hook_recvfrom(SOCKET s, char* buf, int len, int flags, struct sockaddr* from, int* fromlen);
	int WSAAPI inhook_recvfrom(SOCKET s, char* buf, int len, int flags, struct sockaddr* from, int* fromlen);

	static int WSAAPI hook_WSASendTo(
		SOCKET s,
		LPWSABUF lpBuffers,
		DWORD dwBufferCount,
		LPDWORD lpNumberOfBytesSent,
		DWORD dwFlags,
		const struct sockaddr* lpTo,
		int iToLen,
		LPWSAOVERLAPPED lpOverlapped,
		LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
		);
	int WSAAPI inhook_WSASendTo(
		SOCKET s,
		LPWSABUF lpBuffers,
		DWORD dwBufferCount,
		LPDWORD lpNumberOfBytesSent,
		DWORD dwFlags,
		const struct sockaddr* lpTo,
		int iToLen,
		LPWSAOVERLAPPED lpOverlapped,
		LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
		);

	static int WSAAPI hook_WSARecvFrom(
		SOCKET s,
		LPWSABUF lpBuffers,
		DWORD dwBufferCount,
		LPDWORD lpNumberOfBytesRecvd,
		LPDWORD lpFlags,
		struct sockaddr* lpFrom,
		LPINT lpFromlen,
		LPWSAOVERLAPPED lpOverlapped,
		LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
		);
	int WSAAPI inhook_WSARecvFrom(
		SOCKET s,
		LPWSABUF lpBuffers,
		DWORD dwBufferCount,
		LPDWORD lpNumberOfBytesRecvd,
		LPDWORD lpFlags,
		struct sockaddr* lpFrom,
		LPINT lpFromlen,
		LPWSAOVERLAPPED lpOverlapped,
		LPWSAOVERLAPPED_COMPLETION_ROUTINE lpCompletionRoutine
		);

	BOOL HackSendTo(SOCKET s, _SockAddr &addrname, LPPRCClient lpC);

	//////////////////////////////////////////////////////////////////////////

	static BOOL WINAPI hook_CreateProcessInternalW(  HANDLE hToken,
		LPCWSTR lpApplicationName,
		LPWSTR lpCommandLine,
		LPSECURITY_ATTRIBUTES lpProcessAttributes,
		LPSECURITY_ATTRIBUTES lpThreadAttributes,
		BOOL bInheritHandles,
		DWORD dwCreationFlags,
		LPVOID lpEnvironment,
		LPCWSTR lpCurrentDirectory,
		LPSTARTUPINFOW lpStartupInfo,
		LPPROCESS_INFORMATION lpProcessInformation,
		PHANDLE hNewToken);

	BOOL WINAPI inhook_CreateProcessInternalW(  HANDLE hToken,
		LPCWSTR lpApplicationName,
		LPWSTR lpCommandLine,
		LPSECURITY_ATTRIBUTES lpProcessAttributes,
		LPSECURITY_ATTRIBUTES lpThreadAttributes,
		BOOL bInheritHandles,
		DWORD dwCreationFlags,
		LPVOID lpEnvironment,
		LPCWSTR lpCurrentDirectory,
		LPSTARTUPINFOW lpStartupInfo,
		LPPROCESS_INFORMATION lpProcessInformation,
		PHANDLE hNewToken);



private:

	ProxySettingsInfo m_psi;

	BOOL m_bHookEnabled;

	CDummyDNS m_DummyDNS;
	CHackedSocket m_HackedSocket;

	FARPROC m_FuncInCloneModule[HOOKAPI_COUNT];
	CLONESTRUCT  m_CloneModule[HOOKMODULE_COUNT];
	MODULENAME   m_ModuleName[HOOKMODULE_COUNT];
	HOOKSTRUCT m_HookedInfo[HOOKAPI_COUNT];

	CString m_szLastError;
	CString m_szPRCPipeName;

};
