/************************************************************************/
/*    2008.01.01 LZX Created                                            */
/*                                                                      */
/*                                                                      */
/************************************************************************/

#include "stdafx.h"
#include "PRCPipeServer.h"
#include "GlobalProxy.h"
#include "ProxyReceptionCentre.h"

//CString g_szPRCPipeServerName;
GUID g_GuidPipeName;

CPRCPipeServer::CPRCPipeServer(CProxyReceptionCentre *pPRC)
	: CPRCXServer(pPRC)
{
	m_hTestEvent = NULL;
	m_hPipeServer = NULL;
	m_hMainThread = NULL;
	m_dwThreadCount = 0;
	m_hNoThreadEvent = NULL;
}

CPRCPipeServer::~CPRCPipeServer(void)
{
}


BOOL CPRCPipeServer::StartupServer()
{
	CString strGuid;
	GUID guid;
	CONST INT nGUIDLen = 16;
	UCHAR szGUID[nGUIDLen+1] = {0};

	memset(&guid, 0, sizeof(GUID));

	//ÿν̵һ  ʱ Ŵһ guid
	if(memcmp(&g_GuidPipeName, &guid, sizeof(GUID)) == 0)
	{
		if(CoCreateGuid(&g_GuidPipeName) != S_OK)
			return FALSE;
	}

	memcpy(&guid, &g_GuidPipeName, sizeof(GUID));
	memcpy(szGUID, &guid, nGUIDLen);

	strGuid.Format(_T("{%.2X%.2X%.2X%.2X-%.2X%.2X-%.2X%.2X-%.2X%.2X-%.2X%.2X%.2X%.2X%.2X%.2X}"),
		szGUID[0],szGUID[1],szGUID[2],szGUID[3],szGUID[4],szGUID[5],szGUID[6],szGUID[7],
		szGUID[8],szGUID[9],szGUID[10],szGUID[11],szGUID[12],szGUID[13],szGUID[14],szGUID[15]);

	m_szPipeName.Format(_T("\\\\.\\pipe\\PRCPipeName%s"), strGuid);

	//m_szPipeName.Format(_T("\\\\.\\pipe\\%s"), PRC_PIPESERVER_NAME);

	ATLTRACE(_T("PRCPipeName: %s\r\n"), m_szPipeName);

	m_hTestEvent = CreateEvent(0, 0, 0, 0);
	m_hNoThreadEvent = CreateEvent(0, 0, 1, 0);//ʼźţ ʾһʼûclient pipe߳
	if(m_hTestEvent == NULL || m_hNoThreadEvent == NULL)
	{
		//
		return FALSE;
	}

	m_bExitThread = FALSE;
	m_threadstatus = threadstatus_ok;
	m_hMainThread = CreateThread(0, 0, mainThread, this, 0, NULL);
	if(m_hMainThread == NULL)
	{
		CloseHandle(m_hTestEvent);
		return FALSE;
	}

	WaitForSingleObject(m_hTestEvent, INFINITE);
	if(m_threadstatus != threadstatus_ready)
	{
		CloseHandle(m_hMainThread);
		m_hMainThread = NULL;
		CloseHandle(m_hTestEvent);
		m_hTestEvent = NULL;
	}

	return TRUE;
}


BOOL CPRCPipeServer::ShutdownServer()
{
	if(m_hMainThread)
	{
		m_bExitThread = TRUE;
		HANDLE hPipe = CreateFile( 
			m_szPipeName,   // pipe name 
			GENERIC_READ |  // read and write access 
			GENERIC_WRITE, 
			0,              // no sharing 
			NULL,           // no security attributes
			OPEN_EXISTING,  // opens existing pipe 
			0,              // default attributes 
			NULL);          // no template file

		if(hPipe != INVALID_HANDLE_VALUE)
			CloseHandle(hPipe);

		WaitForSingleObject(m_hMainThread, INFINITE);
		CloseHandle(m_hMainThread);
		m_hMainThread = NULL;

		WaitForSingleObject(m_hNoThreadEvent, INFINITE);
		CloseHandle(m_hNoThreadEvent);
		m_hNoThreadEvent = NULL;

		ATLASSERT(m_dwThreadCount == 0);
		ATLASSERT(m_ChildThreadList.size() == 0);

	}

	if(m_hTestEvent)
	{
		CloseHandle(m_hTestEvent);
		m_hTestEvent = NULL;
	}
	return TRUE;
}

CString CPRCPipeServer::GetPipeName()
{
	return m_szPipeName;
}

void CPRCPipeServer::SetThreadStatus(int status)
{
	m_threadstatus = status;
	SetEvent(m_hTestEvent); 
}

DWORD WINAPI CPRCPipeServer::mainThread(LPVOID lParam)
{
	return ((CPRCPipeServer*)lParam)->_mainThread();
}

DWORD WINAPI CPRCPipeServer::_mainThread()
{
	BOOL bInit = FALSE;
	for(;;)
	{
		m_hPipeServer = CreateNamedPipe( 
			m_szPipeName,             // pipe name 
			PIPE_ACCESS_DUPLEX,       // read/write access 
			PIPE_TYPE_MESSAGE |       // message type pipe 
			PIPE_READMODE_MESSAGE |   // message-read mode 
			PIPE_WAIT,                // blocking mode 
			PIPE_UNLIMITED_INSTANCES, // max. instances  
			MAXBUFSIZE,                  // output buffer size 
			MAXBUFSIZE,                  // input buffer size 
			INFINITE,                   // client time-out 
			NULL);                    // default security attribute 

		if (m_hPipeServer == INVALID_HANDLE_VALUE) 
		{
			ATLTRACE("CreatePipe failed: %d\r\n", GetLastError());
			SetThreadStatus(threadstatus_error);
			return 0;
		}

		if(!bInit)
		{
			SetThreadStatus(threadstatus_ready);
			bInit = TRUE;
		}

		BOOL fConnected = ConnectNamedPipe(m_hPipeServer, NULL) ? TRUE : (GetLastError() == ERROR_PIPE_CONNECTED); 

		if(fConnected && !m_bExitThread)
		{
			//ź
			InterlockedIncrement(&m_dwThreadCount);
			ResetEvent(m_hNoThreadEvent);

			DWORD *pParam = new DWORD[3];
			HANDLE hThread = CreateThread(0, 0, InstanceThread, pParam, CREATE_SUSPENDED, NULL);
			pParam[0] = (DWORD)this;
			pParam[1] = (DWORD)m_hPipeServer;
			pParam[2] = (DWORD)hThread;

			CTSList<HANDLE>::critical lc = m_ChildThreadList;
			m_ChildThreadList.push_back(hThread);
			ResumeThread(hThread);

		}

		if(m_bExitThread)
		{
			DisconnectNamedPipe(m_hPipeServer);
			CloseHandle(m_hPipeServer);
			SetThreadStatus(threadstatus_abort);
			break;
		}
	}

	return 0;
}

DWORD WINAPI CPRCPipeServer::InstanceThread(LPVOID lParam) 
{
	DWORD *pParam = (DWORD*)lParam;
	CPRCPipeServer *_this = (CPRCPipeServer*)pParam[0];
	HANDLE hPipe = (HANDLE)pParam[1];
	HANDLE hThread = (HANDLE)pParam[2];
	delete[] pParam;
	return _this->_InstanceThread(hPipe, hThread);
}

DWORD WINAPI CPRCPipeServer::_InstanceThread(HANDLE hPipe, HANDLE hThread)
{
	BOOL bRet;
	PRCPipeDataHead hdr;
	
	for(; !m_bExitThread ;)
	{

		DWORD TotalBytesAvail = 0;

		if (!PeekNamedPipe(
			hPipe,
			NULL,
			NULL,
			NULL,
			&TotalBytesAvail,
			NULL)
			)
			break;

		if (!TotalBytesAvail)
		{
			Sleep(10);
			continue;
		}

		bRet = ReadPipe(hPipe, &hdr, sizeof(hdr));
		if(! bRet)
			break;

		switch(hdr.action)
		{
		case PRCPD_GETSTARTUPINFO:
			{
				PRCINFO info;
				if (!m_pPRC->GetStartupInfo(&info))
					goto SEC_ERROR;

				//дЭͷ
				hdr.action = PRCPD_REPLY;
				hdr.flag = 1;// means true
				hdr.dataSize = sizeof(info); //Эͷݳ
				if (! WritePipe(hPipe, &hdr, sizeof(hdr)))
					goto SEC_ERROR;
				//д
				if (! WritePipe(hPipe, &info, sizeof(info)))
					goto SEC_ERROR;

			}
			break;

		case PRCPD_REGISTERCLIENT:
			{
				//յǼϢ
				PRCClient client;
				//жݳǷ
				if (hdr.dataSize != sizeof(client))
					goto SEC_ERROR;

				if (! ReadPipe(hPipe, &client, hdr.dataSize))
					goto SEC_ERROR;

				//עᵽPRC
				if (! m_pPRC->RegisterClient(&client))
					goto SEC_ERROR;

				//ظɹϢ
				hdr.action = PRCPD_REPLY;
				hdr.flag = 1;

				//ǵǼ UDP RegisterClient ᷵µݵclient ظ֮
				if (client.sType == SOCK_DGRAM)
				{
					hdr.dataSize = sizeof(client);
					if(! WritePipe(hPipe, &hdr, sizeof(hdr)))
						goto SEC_ERROR;

					if (! WritePipe(hPipe, &client, sizeof(client)))
						goto SEC_ERROR;
				}else
				{
					hdr.dataSize = 0;
					if (! WritePipe(hPipe, &hdr, sizeof(hdr)))
						goto SEC_ERROR;
				}

			}
			break;
		
		case PRCPD_UNREGISTER_CLIENT:
			{
				PRCClient client;
				//жݳǷ
				if(hdr.dataSize != sizeof(client))
					goto SEC_ERROR;

				if (! ReadPipe(hPipe, &client, hdr.dataSize))
					goto SEC_ERROR;

				if (! m_pPRC->UnregisterClient(&client))
					goto SEC_ERROR;

				//ظɹϢ
				hdr.action = PRCPD_REPLY;
				hdr.flag = 1;

				hdr.dataSize = 0;
				if (! WritePipe(hPipe, &hdr, sizeof(hdr)))
					goto SEC_ERROR;

			}
			break;

		case PRCPD_CANPROXYME:
			{
				PRCClientInfo clientinfo;
				//жݳǷ
				if (hdr.dataSize != sizeof(clientinfo))
					goto SEC_ERROR;

				if(! ReadPipe(hPipe, &clientinfo, hdr.dataSize))
					goto SEC_ERROR;

				//ѯPRC
				BOOL bFiltered = m_pPRC->IsFiltered(&clientinfo);

				//ظϢ
				hdr.action = PRCPD_REPLY;
				//flagΪ false, means can not
				hdr.flag = (BYTE)!bFiltered;
				hdr.dataSize = 0;
				if (! WritePipe(hPipe, &hdr, sizeof(hdr)))
					goto SEC_ERROR;
			}
			break;

		case PRCPD_GET_SETTINGS_INFO:
			{
				ProxySettingsInfo psi;

				bRet = m_pPRC->GetProxySettingsInfo(&psi);

				//дЭͷ
				hdr.action = PRCPD_REPLY;
				hdr.flag = bRet ? true : false;

				if(bRet)
				{
					hdr.dataSize = sizeof(psi); //Эͷݳ
					if (! WritePipe(hPipe, &hdr, sizeof(hdr)))
						goto SEC_ERROR;
					//д
					if (! WritePipe(hPipe, &psi, sizeof(psi)))
						goto SEC_ERROR;
				}else
				{
					hdr.dataSize = 0;
					if (! WritePipe(hPipe, &hdr, sizeof(hdr)))
						goto SEC_ERROR;
				}

			}
			break;

		case PRCPD_ON_CREATEPROCESS:
			{
				HookNewProcessInfo hnpi;

				if (hdr.dataSize != sizeof(hnpi))
					goto SEC_ERROR;

				if(! ReadPipe(hPipe, &hnpi, hdr.dataSize))
					goto SEC_ERROR;

				//дЭͷ
				hdr.action = PRCPD_REPLY;
				hdr.flag = true;
				hdr.dataSize = 0;

				m_pPRC->m_pGlobalProxy->GetLogInstance()->OnNewProcess(&hnpi);

				if (! WritePipe(hPipe, &hdr, sizeof(hdr)))
					goto SEC_ERROR;


			}
			break;

		case PRCPD_GET_CLIENT_UDPPORT_STATE:
			{
				UDPLocalProxyAddrInfo udpai;

				if (hdr.dataSize != sizeof(udpai))
					goto SEC_ERROR;

				if(! ReadPipe(hPipe, &udpai, hdr.dataSize))
					goto SEC_ERROR;

				//дЭͷ
				hdr.action = PRCPD_REPLY;
				hdr.flag = (BYTE)m_pPRC->GetUDPClientPortState(&udpai);
				hdr.dataSize = 0;

				if (! WritePipe(hPipe, &hdr, sizeof(hdr)))
					goto SEC_ERROR;

			}
			break;

		case PRCPD_GET_PROXYINFO:
			{
				ProxyInfo pi;

				//PRCClientϢ
				PRCClient client;
				//жݳǷ
				if (hdr.dataSize != sizeof(client))
					goto SEC_ERROR;

				if (! ReadPipe(hPipe, &client, hdr.dataSize))
					goto SEC_ERROR;

				bRet = m_pPRC->GetProxyInfo(&client, &pi);

				hdr.action = PRCPD_REPLY;
				hdr.flag = bRet ? true : false;

				if(bRet)
				{
					hdr.dataSize = sizeof(pi);
					if (! WritePipe(hPipe, &hdr, sizeof(hdr)))
						goto SEC_ERROR;
					if (! WritePipe(hPipe, &pi, sizeof(pi)))
						goto SEC_ERROR;
				}else
				{
					hdr.dataSize = 0;
					if (! WritePipe(hPipe, &hdr, sizeof(hdr)))
						goto SEC_ERROR;
				}
			}
			break;

		default:
			goto SEC_ERROR;
		}
	}

SEC_ERROR:
	DisconnectNamedPipe(hPipe);
	CloseHandle(hPipe);

	CTSList<HANDLE>::critical lc = m_ChildThreadList;
	m_ChildThreadList.remove(hThread);
	CloseHandle(hThread);

	//ǰ߳˳û߳ˣ ź
	if (InterlockedDecrement(&m_dwThreadCount) == 0)
	{
		SetEvent(m_hNoThreadEvent);
	}

	return 0;
}

BOOL CPRCPipeServer::WritePipe(HANDLE hPipe, LPVOID lpBuf, int size)
{
	DWORD nWritten = 0;

	if(!WriteFile(hPipe, lpBuf, size, &nWritten, NULL))
		return FALSE;

	return nWritten == (DWORD)size;
}

BOOL CPRCPipeServer::ReadPipe(HANDLE hPipe, LPVOID lpBuf, int size)
{
	DWORD nRead = 0;
	if(!ReadFile(hPipe, lpBuf, size, &nRead, NULL))
		return FALSE;

	return nRead == (DWORD)size;
}
