

#pragma once


typedef unsigned char		byte;
typedef unsigned char		*pbyte;
typedef unsigned long ulong;
typedef char	*pchar;
typedef void	*pvoid;
typedef short	*pshort;
typedef long	*plong;

typedef long NTSTATUS;
#define STATUS_UNSUCCESSFUL ((NTSTATUS)0xC0000001L)
#define STATUS_SUCCESS ((NTSTATUS)0x00000000L) 
#define NT_SUCCESS(Status) ((NTSTATUS)(Status) >= 0)

#define DETOUR_INSTRUCTION_TARGET_NONE          ((pbyte)0)
#define DETOUR_INSTRUCTION_TARGET_DYNAMIC   ((pbyte)~0ul)



NTSTATUS __stdcall detour_sanity_check();


//
//src һָdst.
//
// dst
//ָĿַ. ֻҪһָĳ,òΪNULL.
//Ϊ,ôָԼصĲᱻ.
//src
//ָԴַ.
//target_pptr
//һЩָĿַ. ĳЩָĿַ. õַָ
//ָ.  calljump.  òΪNULL
//extra
//ָĿҪչֽ. ָһ1ֽڵƫ
//Ҫһ4ֽڵƫ.ôextra =3 .
//ֵ
//srcһָĵַ.
//ע
//߿target_pptrָ. ,ЩָĿַ
//޷̬.  һjumpָĿַ洢ĳĴ.
//޷̬jumptargetַ. ,target_pptr
//궨ʾ
//		DETOUR_INSTRUCTION_TARGET_NONE
//			ָûĿ
//		DETOUR_INSTRUCTION_TARGET_DYNAMIC
//			ָĿַǶ̬
pbyte __stdcall detour_copy_instruction(pbyte dst , pbyte src , pbyte * target_pptr , long* extra);
//




//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////////
//
inline PBYTE DetourGenMovEax(PBYTE pbCode, UINT32 nValue)
{
	*pbCode++ = 0xB8;
	*((UINT32*&)pbCode)++ = nValue;
	return pbCode;
}

inline PBYTE DetourGenMovEbx(PBYTE pbCode, UINT32 nValue)
{
	*pbCode++ = 0xBB;
	*((UINT32*&)pbCode)++ = nValue;
	return pbCode;
}

inline PBYTE DetourGenMovEcx(PBYTE pbCode, UINT32 nValue)
{
	*pbCode++ = 0xB9;
	*((UINT32*&)pbCode)++ = nValue;
	return pbCode;
}

inline PBYTE DetourGenMovEdx(PBYTE pbCode, UINT32 nValue)
{
	*pbCode++ = 0xBA;
	*((UINT32*&)pbCode)++ = nValue;
	return pbCode;
}

inline PBYTE DetourGenMovEsi(PBYTE pbCode, UINT32 nValue)
{
	*pbCode++ = 0xBE;
	*((UINT32*&)pbCode)++ = nValue;
	return pbCode;
}

inline PBYTE DetourGenMovEdi(PBYTE pbCode, UINT32 nValue)
{
	*pbCode++ = 0xBF;
	*((UINT32*&)pbCode)++ = nValue;
	return pbCode;
}

inline PBYTE DetourGenMovEbp(PBYTE pbCode, UINT32 nValue)
{
	*pbCode++ = 0xBD;
	*((UINT32*&)pbCode)++ = nValue;
	return pbCode;
}

inline PBYTE DetourGenMovEsp(PBYTE pbCode, UINT32 nValue)
{
	*pbCode++ = 0xBC;
	*((UINT32*&)pbCode)++ = nValue;
	return pbCode;
}

inline PBYTE DetourGenPush(PBYTE pbCode, UINT32 nValue)
{
	*pbCode++ = 0x68;
	*((UINT32*&)pbCode)++ = nValue;
	return pbCode;
}

inline PBYTE DetourGenPushad(PBYTE pbCode)
{
	*pbCode++ = 0x60;
	return pbCode;
}

inline PBYTE DetourGenPopad(PBYTE pbCode)
{
	*pbCode++ = 0x61;
	return pbCode;
}

inline PBYTE DetourGenJmp(PBYTE pbCode, PBYTE pbJmpDst, PBYTE pbJmpSrc = 0)
{
	if (pbJmpSrc == 0) {
		pbJmpSrc = pbCode;
	}
	*pbCode++ = 0xE9;
	*((INT32*&)pbCode)++ = pbJmpDst - (pbJmpSrc + 5);
	return pbCode;
}

inline PBYTE DetourGenCall(PBYTE pbCode, PBYTE pbJmpDst, PBYTE pbJmpSrc = 0)
{
	if (pbJmpSrc == 0) {
		pbJmpSrc = pbCode;
	}
	*pbCode++ = 0xE8;
	*((INT32*&)pbCode)++ = pbJmpDst - (pbJmpSrc + 5);
	return pbCode;
}

inline PBYTE DetourGenBreak(PBYTE pbCode)
{
	*pbCode++ = 0xcc;
	return pbCode;
}

inline PBYTE DetourGenRet(PBYTE pbCode)
{
	*pbCode++ = 0xc3;
	return pbCode;
}

inline PBYTE DetourGenNop(PBYTE pbCode)
{
	*pbCode++ = 0x90;
	return pbCode;
}